<template>
  <div
    class="zone-chunk"
    :class="[
      mergedGlobalType.uiMeta?.classNames,
      mergedSecretType?.uiMeta?.classNames,
      { 'is-secret': chunk.secret !== undefined },
    ]"
    :data-count="chunk.count"
    :data-offset="chunk.offset"
    :style="[mergedGlobalType.uiMeta?.styles, mergedSecretType?.uiMeta?.styles]"
  >
    <div
      class="global"
      v-if="chunk.secret === undefined"
      v-tooltip:top.html="mergedGlobalType.description"
    >
      {{ mergedGlobalType.label }}
    </div>
    <div
      class="secret"
      v-if="chunk.secret !== undefined"
      v-tooltip:top.html="mergedSecretType.description"
    >
      {{ mergedSecretType.label }}
    </div>
    <div
      class="actions--global"
      v-if="actions?.[ElementType.GLOBAL].length > 0"
    >
      <button
        class="action"
        type="button"
        v-for="action in actions[ElementType.GLOBAL]"
        :key="action"
        v-tooltip:bottom.html="action.description"
        @click="gameState?.perform(action, position)"
      >
        {{ action.name }}
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, toRaw } from "vue";
import { ElementType, GameIds } from "@raining.cards/common";
import {
  UIActionSchemaTargetLookup,
  UIGameState,
  UIMaterialChunk,
  UIMaterialPosition,
  UIZone,
} from "@raining.cards/client";
import { mapValues } from "@raining.cards/util";
import { useMergedType } from "@/util/use-merged-type";

export default defineComponent({
  props: {
    gameState: {
      type: Object as PropType<UIGameState>,
      default: null,
    },
    zone: { type: Object as PropType<UIZone>, required: true },
    chunk: {
      type: Object as PropType<UIMaterialChunk>,
      required: true,
    },
    materialActions: {
      type: Object as PropType<UIActionSchemaTargetLookup<
        GameIds,
        ElementType.MATERIAL
      > | null>,
      default: null,
    },
  },
  setup(props) {
    const mergedGlobalType = useMergedType(() => props.chunk.global);
    const mergedSecretType = useMergedType(() => props.chunk.secret);

    const position = computed(
      (): UIMaterialPosition => {
        const { offset, count } = props.chunk;
        return { zone: toRaw(props.zone), index: offset + count - 1 };
      }
    );

    const actions = computed(
      () =>
        props.materialActions &&
        mapValues(props.materialActions, (list) =>
          list.filter((action) => action.checkOrigin(position.value))
        )
    );

    return {
      ElementType,
      position,
      actions,
      mergedGlobalType,
      mergedSecretType,
    };
  },
});
</script>

<style lang="scss" scoped>
@import "!/styles/variables";
@import "!/styles/mixins";

.zone-chunk {
  min-width: 48px;
  min-height: 48px;
  padding: $spacing-md;
  display: flex;
  flex-direction: column;
  height: 100%;
  position: relative;
  border: $spacing-xs solid transparent;
  font-size: 0.75rem;

  &.is-secret {
    border-color: #879185;
  }

  &[data-count="1"]::before {
    display: none;
  }

  &::before {
    content: attr(data-count);
    color: $black;
    font-size: 0.75rem;
    position: absolute;
    // negative border-width plus negative xs spacing
    right: -$spacing-xs - $spacing-xs;
    top: -$spacing-xs - $spacing-xs;
    border-radius: 50%;
    display: block;
    background-color: $white;
    font-weight: 600;
    width: 1.6em;
    height: 1.6em;
    text-align: center;
    box-shadow: 0 0 2px fade-out($black, 0.5);
  }
}

.global,
.secret {
  flex: 1;
  display: flex;
  justify-content: center;
  align-items: center;
}

.secret {
  font-weight: 600;

  &:not(:first-child) {
    border-top: 2px solid gray;
    margin-top: $spacing-xs;
  }
}

.actions--global {
  display: flex;
  margin: (-$spacing-xs / 2 + $spacing-xs) (-$spacing-sm / 2)
    (-$spacing-xs / 2 - $spacing-md);

  > * {
    margin: ($spacing-xs / 2) ($spacing-sm / 2);
  }
}

button.action {
  @include action-button;
  padding: $spacing-xs $spacing-sm;
}
</style>
